---
policy: /ce/ca/aws/redshift/cluster-ecryption-at-rest
logic: /ce/ca/aws/redshift/cluster-ecryption-at-rest/prod.logic.yaml
executionTime: 2026-01-31T12:02:16.489852637Z
generationMs: 103
executionMs: 668
rows:
  - id: '001'
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__encryption__c') != 'Enabled'
      actual: extract('CA10__encryption__c') != 'Enabled'
    runtimeError: {}
  - id: '002'
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 300
      actual: 300
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/redshift/cluster-ecryption-at-rest/policy.yaml
    md5Hash: 6C3A0D38C5EEC15E2089FCA4222E2FA3
    content: "---\nnames:\n  full: \"AWS Redshift Cluster is not encrypted at rest\"\
      \n  contextual: \"Cluster is not encrypted at rest\"\ndescription: >\n  Ensure\
      \ that Amazon Redshift clusters are encrypted at rest to protect sensitive \n\
      \  data from unauthorized access to the underlying storage. Encryption helps\
      \ meet \n  regulatory requirements and provides an additional layer of data\
      \ protection.\ntype: \"COMPLIANCE_POLICY\"\ncategories:\n  - \"SECURITY\"\n\
      frameworkMappings:\n  - \"/frameworks/cloudaware/resource-security/data-encryption\"\
      \n  - \"/frameworks/aws-fsbp-v1.0.0/redshift/10\"\n  - \"/frameworks/aws-well-architected/sec/08/02\"\
      \nsimilarPolicies:\n  awsSecurityHub:\n    - name: \"[Redshift.10] Redshift\
      \ clusters should be encrypted at rest\"\n      url: \"https://docs.aws.amazon.com/securityhub/latest/userguide/redshift-controls.html#redshift-10\"\
      \n    "
  - path: /ce/ca/aws/redshift/cluster-ecryption-at-rest/prod.logic.yaml
    md5Hash: 88E87AABE894404A32C250CBD6BD72D1
    content: |-
      ---
      inputType: "CA10__CaAwsRedshiftCluster__c"
      importExtracts:
        - file: "/types/CA10__CaAwsRedshiftCluster__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The Cluster is not available."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__status__c"
              right:
                TEXT: "available"
        - status: "COMPLIANT"
          currentStateMessage: "The Cluster encrypted at rest."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__encryption__c"
              right:
                TEXT: "Enabled"
      otherwise:
        status: "INCOMPLIANT"
        currentStateMessage: "The Cluster is not encrypted at rest."
        remediationMessage: "Enable encryption to the cluster"
  - path: /ce/ca/aws/redshift/cluster-ecryption-at-rest/test-data.json
    md5Hash: 881EFCA26691117FE90F0D7D50F6E902
    content: |
      [
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "299",
            "conditionText": "extract('CA10__encryption__c') != 'Enabled'",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-12-21T23:51:55Z" },
          "CA10__disappearanceTime__c": null,
          "CA10__status__c": "available",
          "CA10__encryption__c": "Disabled",
          "Id": "001"
        },
        {
          "expectedResult": {
            "status": "INCOMPLIANT",
            "conditionIndex": "300",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": { "snapshotTime": "2025-12-21T23:51:55Z" },
          "CA10__disappearanceTime__c": null,
          "CA10__status__c": "available",
          "CA10__encryption__c": "Enabled",
          "Id": "002"
        }
      ]
  - path: /types/CA10__CaAwsRedshiftCluster__c/object.extracts.yaml
    md5Hash: DBF4D0413CB4EF01D13D17E4ED636EC5
    content: |
      ---
      extracts:
      # Nullable. Values: available, modifying, creating ...
        - name: "CA10__status__c"
          value:
            FIELD:
              path: "CA10__status__c"
      # Nullable.
        - name: "CA10__createTime__c"
          value:
            FIELD:
              path: "CA10__createTime__c"
      # Nullable.
        - name: "CA10__cpuUtilizationAvg30d__c"
          value:
            FIELD:
              path: "CA10__cpuUtilizationAvg30d__c"
      # Nullable.
        - name: "CA10__diskReadIopsAvg30d__c"
          value:
            FIELD:
              path: "CA10__diskReadIopsAvg30d__c"
      # Nullable.
        - name: "CA10__diskWriteIopsAvg30d__c"
          value:
            FIELD:
              path: "CA10__diskWriteIopsAvg30d__c"
      # Nullable.
        - name: "CA10__logging__c"
          value:
            FIELD:
              path: "CA10__logging__c"
      # Nullable.
        - name: "CA10__automatedSnapshotRetentionPeriod__c"
          value:
            FIELD:
              path: "CA10__automatedSnapshotRetentionPeriod__c"
      # Text.
        - name: "CA10__encryption__c"
          value:
            FIELD:
              path: "CA10__encryption__c"
      # Text.
        - name: "CA10__masterUsername__c"
          value:
            FIELD:
              path: "CA10__masterUsername__c"
      # Text.
        - name: "CA10__versionUpgrade__c"
          value:
            FIELD:
              path: "CA10__versionUpgrade__c"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "001",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__encryption__c') != 'Enabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "002",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "300",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsRedshiftCluster__c()
  RETURNS ARRAY<STRUCT<
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__status__c STRING,
      CA10__encryption__c STRING,
      Id STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-12-21T23:51:55Z")
    },
    "CA10__status__c" : "available",
    "CA10__encryption__c" : "Disabled",
    "Id" : "001"
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-12-21T23:51:55Z")
    },
    "CA10__status__c" : "available",
    "CA10__encryption__c" : "Enabled",
    "Id" : "002"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsRedshiftCluster__c(
      obj STRUCT<
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__status__c STRING,
          CA10__encryption__c STRING,
          Id STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
  var TextLib = new function () {
      this.normalize = function(arg) {
          return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
      };
      this.isEmpty = function(arg) {
          return this.normalize(arg) == '';
      };
      this.isNotEmpty = function(arg) {
          return this.normalize(arg) != '';
      };
      this.equal = function(left, right) {
          return this.normalize(left) == this.normalize(right);
      };
      this.notEqual = function(left, right) {
          return this.normalize(left) != this.normalize(right);
      };
      this.startsWith = function(arg, substring) {
          return this.normalize(arg).startsWith(this.normalize(substring));
      };
      this.endsWith = function(arg, substring) {
          return this.normalize(arg).endsWith(this.normalize(substring));
      };
      this.contains = function(arg, substring) {
          return this.normalize(arg).includes(this.normalize(substring));
      };
      this.containsAll = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
      };
      this.containsAny = function(arg, substrings) {
          if (substrings == null || substrings.length === 0) return false;
          let normalizedArg = this.normalize(arg);
          return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
      };
  }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function extract3() { if (!this.out) { this.out = obj.CA10__status__c; } return this.out; };
      references1.push('Status [obj.CA10__status__c]: ' + obj.CA10__status__c);
      if (TextLib.notEqual(extract3.call(extract3), 'available')) {
          return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__status__c') != 'available'", currentStateMessage: "The Cluster is not available.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[2], conditionIndex:[200..299]
      function extract6() { if (!this.out) { this.out = obj.CA10__encryption__c; } return this.out; };
      references1.push('Encryption [obj.CA10__encryption__c]: ' + obj.CA10__encryption__c);
      if (TextLib.notEqual(extract6.call(extract6), 'Enabled')) {
          return {status: 'COMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__encryption__c') != 'Enabled'", currentStateMessage: "The Cluster encrypted at rest.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      return {status: 'INCOMPLIANT', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "The Cluster is not encrypted at rest.", currentStateReferences: references1.join('\n'), remediation: "Enable encryption to the cluster", runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__status__c AS CA10__status__c,
          sObject.CA10__encryption__c AS CA10__encryption__c,
          sObject.Id AS Id,
          process_CA10__CaAwsRedshiftCluster__c(
              STRUCT(
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__status__c AS CA10__status__c,
                  sObject.CA10__encryption__c AS CA10__encryption__c,
                  sObject.Id AS Id
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsRedshiftCluster__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
